#pragma once

#include "stdafx.h"
#include "BGS/AdaptiveMedianBGS.hpp"

class Background
{
public:
	Background();
	~Background(void);

	// complex
	void		initBackgroundComplex();
	void		setBackgroundImageComplex(IplImage* img);
	void		subtractComplex(IplImage* img);

	// simple
	void		setBackgroundImageSimple(IplImage* img);
	void		subtractSimple(IplImage* img);
public:
	IplImage*	subtractedImage;

protected:
	//complex
	Algorithms::BackgroundSubtraction::AdaptiveMedianBGS*			bgs;
	Algorithms::BackgroundSubtraction::AdaptiveMedianParams*	params;
	BwImage*													low_threshold_mask;
	BwImage*													high_threshold_mask;
	IplImage*													compTempImage;
	IplImage*													compTempImageBW;
	RgbImage*													compBgImage;
	int															frame_count;
	// simple
	IplImage*	bgImage;
	IplImage*	tmpImage;

	// general
	bool		bgSet;
};
