#pragma once

#include <winsock2.h>
#include "Socket.h"
#include "HVCore.h"

#define FI_SOCKET_MAX 5

// commands
#define CMD_TOGGLE "toggle"
#define CMD_START "start"
#define CMD_STOP "stop"
#define CMD_RESET "reset"
#define CMD_EXIT "exit"

class HVCore;

/** Flash-Interface **/
class FI
{
public:
	FI(int port, HVCore* core = NULL);
	~FI(void);
	void send(float relX, float relY, double depth, char* state);


	// socket
	SocketServer* server;
	static unsigned _stdcall handleThread(void* ref);
	static unsigned _stdcall checkRequests(void* ref);
	static unsigned int numSockets;
	static Socket* sockets[FI_SOCKET_MAX];


	static HVCore*		core;
protected:
	static bool			running;
};