#pragma once

#include "stdafx.h"
#include "HandVuLite.h"

class Gesture
{
public:
	Gesture(int radius = 50, int xoffset = 0, int yoffset = 0);
	~Gesture(void);

	// filter functions
	void amplify(IplImage* img, IplImage* destImg, float level);
	void highpass(IplImage* img, IplImage* tmp, float blur1, float blur2);

	// contours
	void calcContours(IplImage* img);
	void calcGesture(CvPoint center, float depth, int overlayLevel = 0);

	// radial processing
	void initRadial(int radius, int xoffset, int yoffset);
	void calcRadial(IplImage* stereoImg, CvPoint p, float depth, int overlayLevel = 0);

	// cross processing
	void resetCxCy(CvPoint p);
	bool isHigher(IplImage* img, int x, int y, float depth);
	void calcCross(IplImage* stereoImg, CvPoint p, float depth, int overlayLevel = 0);

public:
	// contour finding
	IplImage*	gestureImage;
	CvSeq*		contours;
	CvMemStorage*	storage;

	char*	state;
	int		pointTrans;
	int		spreadTrans;
protected:
	// ### contour finding ###
	IplImage*	tempImg;
	IplImage*	tempImg2;

	// ### cross detection ###
	int tl, tr, bl, br;
	// ### radial detection ###
	// circle
	std::vector<CvPoint>* fPoints;
	// process vars
	CvPoint			circle;
	int				c_x, c_y;
	float			actBright;
	int				white_count;
	// saved vars
	int				rad;
	int				xOff;
	int				yOff;
	float			prevDepth;
};
