#pragma once

#include "stdafx.h"
#include "videoInput.h"
#include "Background.h"

class HVCamera
{
public:
	HVCamera(videoInput *vi, int device, float* distTopOffset = 0, float* distBottomOffset = 0);
	~HVCamera(void);
	void run(void);
	void draw(IplImage* img = NULL);
	void setBg(bool complex = true);
protected:
	int device;
	videoInput *vi;
	// image distortion
	CvPoint2D32f src_quad[4];
	CvPoint2D32f dest_quad[4];
	Background* bg;
	bool bgComplexMode;
public:
	// output image
	IplImage* rawImage;
	IplImage* grayImage;
	IplImage* image;
	// image distortion
	float* distTopOffset;
	float* distBottomOffset;
	// ### pref vars ###
	bool showCenter;
};