#pragma once

#include "stdafx.h"
#include "HandVuLite.h"
#include "HVCamera.h"
#include "CI.h"
#include "FI.h"
#include "videoInput.h"
#include "StereoView.h"
#include "WindowOutput.h"
#include "Gesture.h"

class FI;

class HVCore
{
public:
	HVCore(bool tracking = true, bool useServer = false, bool saveCapture = false);
	~HVCore(void);
	void process(void);
	void run();
	void track(void);
	void draw(void);
	static void keydown(int key, int action);
	void doCommand(char* cmd);

	// settings
	void saveSettings(void);
	void loadSettings(void);
	void resetSettings(void);

public:
	// calibrate
	CvRect			calRect;

protected:
	static HVCore*			instance;
	bool			dual;
	bool			tracking;
	bool			useServer;
	int				showImages;
	int				overlayLevel;
	bool			saveCapture;

	// calibrate
	bool			stereoCalibration;
	bool			calibrate;
	bool			showCenter;
	bool			drawCalibrationLines;

	// auto start tracking
	int autoTracking;

	// distortion
	float			distTopOffset;
	float			distBottomOffset;

	// external classes
	videoInput*		vi;
	IplImage*		tmpImg;

	// internal classes
	HVCamera*		cam[2];
	HandVuLite*		hand;
	StereoView*		sview;
	WindowOutput*	wout;
	FI*				fi;
	CI*				ci;
	Gesture*		gesture;

	// keys
	static int		factor;
	static bool		ctrl;
};
