// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently, but
// are changed infrequently
//

#pragma once


#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers

#include <ctime>
#include <iostream>
#include <math.h>
#include <cv.h>
#include <cxcore.h>
#include <cvaux.h>
#include <highgui.h>
#include "glfw.h"
#include "BGS/Image.hpp"

#include <iostream>
#include <sstream>

// color or b/w ? (GL_RGB, GL_LUMINANCE);
#define CAM_COLOR GL_LUMINANCE
// size of each connected camera (you have to do a new calibration, if changing the size)
#define CAM_W 640
#define CAM_H 480
// size of each display output window image
#define CAM_WIN_W 320
#define CAM_WIN_H 240
// disparity calculation size (ROI = region of interest)
#define CAM_DISPARITY_W 320
#define CAM_DISPARITY_H 240
#define DISP_CAM_FACTOR (CAM_W / CAM_DISPARITY_W)
// highpass transition value (0 ... 255)
#define HIGHPASS_MIN_VAL 70

// filename settings (%i will be replaced with CAM_W)
#define HV11_CONDUCTOR_FILENAME "config/hv%i.conductor"
#define HV11_CAL_FILENAME "calibration%i.hv"
#define HV11_SETTINGS_FILENAME "settings%i.hv"
#define HV11_LOAD_SETTINGS_ON_STARTUP true

#define CI_CAPTURE_INTERVAL 50 // in ms
#define CI_SIZE_X 64
#define CI_SIZE_Y 32

#define	PI 3.141592654
